// VTC1911_IPK G-Sensor SDK V1.0 2018/01/23
#define VTC1911_IPK_GSENSOR_API extern "C" _declspec(dllimport)

VTC1911_IPK_GSENSOR_API void Get_DLL_Version(int* nMajorVersion, int* nMinorVersion);

VTC1911_IPK_GSENSOR_API int  Library_Initial();   // Initial Library   // return = 0 => Failed, return = 1 => Success
VTC1911_IPK_GSENSOR_API void Library_Release();   // Release Library

VTC1911_IPK_GSENSOR_API int  InitAccelerometer(); // return = 1 => Success,
                                                  // return = 0 => failed,
                                                  // return = -2 => G-sensor is busy,
                                                  // return = -3 => Time out (5 sec).

VTC1911_IPK_GSENSOR_API int  G_Sensor_Read(unsigned char byRegister, unsigned char *byData); // return = 1 => Success, 
                                                                                             // return = 0 => read failed,
                                                                                             // return = -1 => The register number is out of range, 
                                                                                             // return = -2 => G-sensor is busy,
                                                                                             // return = -3 => Time out (5 sec).

VTC1911_IPK_GSENSOR_API int  G_Sensor_Write(unsigned char byRegister, unsigned char byData); // return = 1 => Success,
                                                                                             // return = 0 => read failed,
                                                                                             // return = -1 => The register number is out of range,
                                                                                             // return = -2 => G-sensor is busy,
                                                                                             // return = -3 => Time out (5 sec).

VTC1911_IPK_GSENSOR_API int  G_Sensor_X_Axis(unsigned short *nXAxis); // return = 1 => Success, return = 0 => failed, return = -2 => G-sensor is busy, return = -3 => Time out (5 sec).
VTC1911_IPK_GSENSOR_API int  G_Sensor_Y_Axis(unsigned short *nYAxis); // return = 1 => Success, return = 0 => failed, return = -2 => G-sensor is busy, return = -3 => Time out (5 sec).
VTC1911_IPK_GSENSOR_API int  G_Sensor_Z_Axis(unsigned short *nZAxis); // return = 1 => Success, return = 0 => failed, return = -2 => G-sensor is busy, return = -3 => Time out (5 sec).
