
// VTC1911_IPK_Gsensor_UtilityDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VTC1911_IPK_Gsensor_Utility.h"
#include "VTC1911_IPK_Gsensor_UtilityDlg.h"
#include "VTC1911_IPK_Gsensor.h"
#include "Useful_Function.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CVTC1911_IPK_Gsensor_UtilityDlg dialog




CVTC1911_IPK_Gsensor_UtilityDlg::CVTC1911_IPK_Gsensor_UtilityDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVTC1911_IPK_Gsensor_UtilityDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVTC1911_IPK_Gsensor_UtilityDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO1, m_CComboBox_GSensorRegIndex);
	DDX_Control(pDX, IDC_EDIT1, m_CEdit_GSensorData);
	DDX_Control(pDX, IDC_EDIT2, m_CEdit_WriteGSensorData);
	DDX_Control(pDX, IDC_LIST1, m_CListCtrl_GSensor);
	DDX_Control(pDX, IDC_EDIT3, m_CEdit_Xaxis);
	DDX_Control(pDX, IDC_EDIT4, m_CEdit_Yaxis);
	DDX_Control(pDX, IDC_EDIT5, m_CEdit_Zaxis);
}

BEGIN_MESSAGE_MAP(CVTC1911_IPK_Gsensor_UtilityDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, &CVTC1911_IPK_Gsensor_UtilityDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CVTC1911_IPK_Gsensor_UtilityDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CVTC1911_IPK_Gsensor_UtilityDlg::OnBnClickedButton3)
END_MESSAGE_MAP()


// CVTC1911_IPK_Gsensor_UtilityDlg message handlers

BOOL CVTC1911_IPK_Gsensor_UtilityDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	m_CComboBox_GSensorRegIndex.ResetContent();
	m_CComboBox_GSensorRegIndex.InsertString(0, TEXT("00 : DEVID"));
	m_CComboBox_GSensorRegIndex.InsertString(1, TEXT("29 : THRESH_TAP"));
	m_CComboBox_GSensorRegIndex.InsertString(2, TEXT("30 : OFSX"));
	m_CComboBox_GSensorRegIndex.InsertString(3, TEXT("31 : OFSY"));
	m_CComboBox_GSensorRegIndex.InsertString(4, TEXT("32 : OFSZ"));
	m_CComboBox_GSensorRegIndex.InsertString(5, TEXT("33 : DUR"));
	m_CComboBox_GSensorRegIndex.InsertString(6, TEXT("34 : Latent"));
	m_CComboBox_GSensorRegIndex.InsertString(7, TEXT("35 : Window"));
	m_CComboBox_GSensorRegIndex.InsertString(8, TEXT("36 : THRESH_ACT"));
	m_CComboBox_GSensorRegIndex.InsertString(9, TEXT("37 : THRESH_INACT"));
	m_CComboBox_GSensorRegIndex.InsertString(10, TEXT("38 : TIME_INACT"));
	m_CComboBox_GSensorRegIndex.InsertString(11, TEXT("39 : ACT_INACT_CTL"));
	m_CComboBox_GSensorRegIndex.InsertString(12, TEXT("40 : THRESH_FF"));
	m_CComboBox_GSensorRegIndex.InsertString(13, TEXT("41 : TIME_FF"));
	m_CComboBox_GSensorRegIndex.InsertString(14, TEXT("42 : TAP_AXES"));
	m_CComboBox_GSensorRegIndex.InsertString(15, TEXT("43 : ACT_TAP_STATUS"));
	m_CComboBox_GSensorRegIndex.InsertString(16, TEXT("44 : BW_RATE"));
	m_CComboBox_GSensorRegIndex.InsertString(17, TEXT("45 : POWER_CTL"));
	m_CComboBox_GSensorRegIndex.InsertString(18, TEXT("46 : INT_ENABLE"));
	m_CComboBox_GSensorRegIndex.InsertString(19, TEXT("47 : INT_MAP"));
	m_CComboBox_GSensorRegIndex.InsertString(20, TEXT("48 : INT_SOURCE"));
	m_CComboBox_GSensorRegIndex.InsertString(21, TEXT("49 : DATA_FORMAT"));
	m_CComboBox_GSensorRegIndex.InsertString(22, TEXT("50 : DATA_X0"));
	m_CComboBox_GSensorRegIndex.InsertString(23, TEXT("51 : DATA_X1"));
	m_CComboBox_GSensorRegIndex.InsertString(24, TEXT("52 : DATA_Y0"));
	m_CComboBox_GSensorRegIndex.InsertString(25, TEXT("53 : DATA_Y1"));
	m_CComboBox_GSensorRegIndex.InsertString(26, TEXT("54 : DATA_Z0"));
	m_CComboBox_GSensorRegIndex.InsertString(27, TEXT("55 : DATA_Z1"));
	m_CComboBox_GSensorRegIndex.InsertString(28, TEXT("56 : FIFO_CTL"));
	m_CComboBox_GSensorRegIndex.InsertString(29, TEXT("57 : FIFO_STATUS"));
	m_CComboBox_GSensorRegIndex.SetCurSel(17);

	m_CEdit_WriteGSensorData.SetWindowText(TEXT("0A"));

	m_CListCtrl_GSensor.DeleteAllItems();
	m_CListCtrl_GSensor.InsertColumn(0, TEXT("Num"));
	m_CListCtrl_GSensor.InsertColumn(1, TEXT("Name"));
	m_CListCtrl_GSensor.InsertColumn(2, TEXT("Type"));
	m_CListCtrl_GSensor.InsertColumn(3, TEXT("Value"));
	m_CListCtrl_GSensor.InsertColumn(4, TEXT("Description"));
	m_CListCtrl_GSensor.SetColumnWidth(0, 40);
	m_CListCtrl_GSensor.SetColumnWidth(1, 110);
	m_CListCtrl_GSensor.SetColumnWidth(2, 40);
	m_CListCtrl_GSensor.SetColumnWidth(3, 40);
	m_CListCtrl_GSensor.SetColumnWidth(4, 300);

	int nResult = Library_Initial(); // Initial Library   // return = 0 => Failed, return = 1 => Success
	if( nResult == 1 )
	{
		nResult = InitAccelerometer();
		if( nResult !=1 )
		{
			MessageBox("Initialize G-Sensor failed!!!");
		}
		else
		{
			OnBnClickedButton2();
			OnBnClickedButton1();
			OnBnClickedButton3();
			SetTimer(1, 300, NULL);
		}
	}
	else
	{
		MessageBox("Load library failed!!!");
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVTC1911_IPK_Gsensor_UtilityDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVTC1911_IPK_Gsensor_UtilityDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVTC1911_IPK_Gsensor_UtilityDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CVTC1911_IPK_Gsensor_UtilityDlg::OnDestroy()
{
	CDialog::OnDestroy();

	Library_Release(); // Release Library
}

BYTE GetAddress(int nIndex)
{
	BYTE byAddress = 0;
	if( nIndex == 0 )
		byAddress = 0;
	else
		byAddress = nIndex + 0x1C;

	if( byAddress < 0 && byAddress > 0x39 )
		byAddress = 0;

	return byAddress;
}

void CVTC1911_IPK_Gsensor_UtilityDlg::OnTimer(UINT_PTR nIDEvent)
{
	if( nIDEvent == 1 )
	{
		unsigned short nXAxis = 0;
		int nResult = G_Sensor_X_Axis(&nXAxis);
		if( nResult == 1 )
		{
			CString strGsensorData;
			short nX = nXAxis;
			strGsensorData.Format(TEXT("%d"), nX);
			m_CEdit_Xaxis.SetWindowText(strGsensorData);
		}
		else
		{
			m_CEdit_Xaxis.SetWindowText(TEXT("?"));
		}

		unsigned short nYAxis = 0;
		nResult = G_Sensor_Y_Axis(&nYAxis);
		if( nResult == 1 )
		{
			CString strGsensorData;
			short nY = nYAxis;
			strGsensorData.Format(TEXT("%d"), nY);
			m_CEdit_Yaxis.SetWindowText(strGsensorData);
		}
		else
		{
			m_CEdit_Yaxis.SetWindowText(TEXT("?"));
		}

		unsigned short nZAxis = 0;
		nResult = G_Sensor_Z_Axis(&nZAxis);
		if( nResult == 1 )
		{
			CString strGsensorData;
			short nZ = nZAxis;
			strGsensorData.Format(TEXT("%d"), nZ);
			m_CEdit_Zaxis.SetWindowText(strGsensorData);
		}
		else
		{
			m_CEdit_Zaxis.SetWindowText(TEXT("?"));
		}
	}

	CDialog::OnTimer(nIDEvent);
}

void CVTC1911_IPK_Gsensor_UtilityDlg::OnBnClickedButton1()
{
	unsigned char byRegister = GetAddress(m_CComboBox_GSensorRegIndex.GetCurSel());
	unsigned char byData = 0;

	int nResult = G_Sensor_Read(byRegister, &byData);
	if( nResult == 1 )
	{
		CString strGsensorData;
		strGsensorData.Format(TEXT("%02X"), byData);
		m_CEdit_GSensorData.SetWindowText(strGsensorData);
	}
	else
	{
		m_CEdit_GSensorData.SetWindowText(TEXT("?"));
	}
}

void CVTC1911_IPK_Gsensor_UtilityDlg::OnBnClickedButton2()
{
	unsigned char byData = 0;

	char szData[8];
	memset(szData, 0, sizeof(szData));

	::GetWindowTextA(m_CEdit_WriteGSensorData.GetSafeHwnd(), szData, sizeof(szData));
	byData = transfer_string_to_hex( (unsigned char*)szData );

	unsigned char byRegister = GetAddress(m_CComboBox_GSensorRegIndex.GetCurSel());

	int nResult = G_Sensor_Write(byRegister, byData);
	if( nResult == 1 )
	{
	}
	else
	{
		MessageBox("Set Gsensor Data Failed!!!");
	}
}

TCHAR g_szName[][20] = {TEXT("DEVID"),
						TEXT("Reserved"),
						TEXT("THRESH_TAP"),
						TEXT("OFSX"),
						TEXT("OFSY"),
						TEXT("OFSZ"),
						TEXT("DUR"),
						TEXT("Latent"),
						TEXT("Window"),
						TEXT("THRESH_ACT"),
						TEXT("THRESH_INACT"),
						TEXT("TIME_INACT"),
						TEXT("ACT_INACT_CTL"),
						TEXT("THRESH_FF"),
						TEXT("TIME_FF"),
						TEXT("TAP_AXES"),
						TEXT("ACT_TAP_STATUS"),
						TEXT("BW_RATE"),
						TEXT("POWER_CTL"),
						TEXT("INT_ENABLE"),
						TEXT("INT_MAP"),
						TEXT("INT_SOURCE"),
						TEXT("DATA_FORMAT"),
						TEXT("DATAX0"),
						TEXT("DATAX1"),
						TEXT("DATAY0"),
						TEXT("DATAY1"),
						TEXT("DATAZ0"),
						TEXT("DATAZ1"),
						TEXT("FIFO_CTL"),
						TEXT("FIFO_STATUS")};

TCHAR g_szType[][5] = {TEXT("R"),
                       TEXT(""),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R"),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R/W"),
					   TEXT("R"),
					   TEXT("R/W"),
					   TEXT("R"),
					   TEXT("R"),
					   TEXT("R"),
					   TEXT("R"),
					   TEXT("R"),
					   TEXT("R"),
					   TEXT("R/W"),
					   TEXT("R")};

TCHAR g_szDescription[][60] = {TEXT("Device ID"),
							   TEXT("Reserved; do not access"),
							   TEXT("Tap threshold"),
							   TEXT("X-axis offset"),
							   TEXT("Y-axis offset"),
							   TEXT("Z-axis offset"),
							   TEXT("Tap duration"),
							   TEXT("Tap latency"),
							   TEXT("Tap window"),
							   TEXT("Activity threshold"),
							   TEXT("Inactivity threshold"),
							   TEXT("Inactivity time"),
							   TEXT("Axis enable control for activity and inactivity detection"),
							   TEXT("Free-fall threshold"),
							   TEXT("Free-fall time"),
							   TEXT("Axis control for single tap/double tap"),
							   TEXT("Source of single tap/double tap"),
							   TEXT("Data rate and power mode control"),
							   TEXT("Power-saving features control"),
							   TEXT("Interrupt enable control"),
							   TEXT("Interrupt mapping control"),
							   TEXT("Source of interrupts"),
							   TEXT("Data format control"),
							   TEXT("X-Axis Data 0"),
							   TEXT("X-Axis Data 1"),
							   TEXT("Y-Axis Data 0"),
							   TEXT("Y-Axis Data 1"),
							   TEXT("Z-Axis Data 0"),
							   TEXT("Z-Axis Data 1"),
							   TEXT("FIFO control"),
							   TEXT("FIFO status")};

void CVTC1911_IPK_Gsensor_UtilityDlg::OnBnClickedButton3()
{
	m_CListCtrl_GSensor.DeleteAllItems();
	m_CListCtrl_GSensor.UpdateWindow();

	unsigned char byRegister = 0;
	unsigned char byData = 0;

	int nResult = G_Sensor_Read(byRegister, &byData);
	if( nResult == 1 )
	{
		CString strGsensorData;
		strGsensorData.Format(TEXT("%02X "), byData);

		m_CListCtrl_GSensor.InsertItem( 0, TEXT("0") );
		m_CListCtrl_GSensor.SetItemText( 0, 1, g_szName[0] );
		m_CListCtrl_GSensor.SetItemText( 0, 2, g_szType[0] );
		m_CListCtrl_GSensor.SetItemText( 0, 3, strGsensorData );
		m_CListCtrl_GSensor.SetItemText( 0, 4, g_szDescription[0] );

		m_CListCtrl_GSensor.InsertItem( 1, TEXT("1~28") );
		m_CListCtrl_GSensor.SetItemText( 1, 1, g_szName[1] );
		m_CListCtrl_GSensor.SetItemText( 1, 2, g_szType[1] );
		m_CListCtrl_GSensor.SetItemText( 1, 3, TEXT("") );
		m_CListCtrl_GSensor.SetItemText( 1, 4, g_szDescription[1] );


		for ( int i=0 ; i<29 ; i++ )
		{
			CString strNum;
			strNum.Format(TEXT("%d"), i+29);

			nResult = G_Sensor_Read(i+29, &byData);
			if( nResult == 1 )
			{
				strGsensorData.Format(TEXT("%02X "), byData);
			}
			else
			{
				strGsensorData = TEXT("?");
			}

			m_CListCtrl_GSensor.InsertItem( i+2, strNum );
			m_CListCtrl_GSensor.SetItemText( i+2, 1, g_szName[i+2] );
			m_CListCtrl_GSensor.SetItemText( i+2, 2, g_szType[i+2] );
			m_CListCtrl_GSensor.SetItemText( i+2, 3, strGsensorData );
			m_CListCtrl_GSensor.SetItemText( i+2, 4, g_szDescription[i+2] );
		}
	}
}
